// Code generated by SQLBoiler (https://github.com/volatiletech/sqlboiler). DO NOT EDIT.
// This file is meant to be re-generated in place and/or deleted at any time.

package postgres

import (
	"context"
	"database/sql"
	"fmt"
	"reflect"
	"strconv"
	"strings"
	"sync"
	"time"

	"github.com/pkg/errors"
	"github.com/volatiletech/sqlboiler/boil"
	"github.com/volatiletech/sqlboiler/queries"
	"github.com/volatiletech/sqlboiler/queries/qm"
	"github.com/volatiletech/sqlboiler/queries/qmhelper"
	"github.com/volatiletech/sqlboiler/strmangle"
	"github.com/volatiletech/sqlboiler/types"
)

// OrderDeal is an object representing the database table.
type OrderDeal struct {
	ID        int64             `boil:"id" json:"id" toml:"id" yaml:"id"`
	OrderID   int64             `boil:"order_id" json:"order_id" toml:"order_id" yaml:"order_id"`
	OfferID   int64             `boil:"offer_id" json:"offer_id" toml:"offer_id" yaml:"offer_id"`
	DriverID  int64             `boil:"driver_id" json:"driver_id" toml:"driver_id" yaml:"driver_id"`
	Price     int64             `boil:"price" json:"price" toml:"price" yaml:"price"`
	Rating    types.NullDecimal `boil:"rating" json:"rating,omitempty" toml:"rating" yaml:"rating,omitempty"`
	Completed bool              `boil:"completed" json:"completed" toml:"completed" yaml:"completed"`
	DTCreated time.Time         `boil:"dt_created" json:"dt_created" toml:"dt_created" yaml:"dt_created"`
	DTUpdated time.Time         `boil:"dt_updated" json:"dt_updated" toml:"dt_updated" yaml:"dt_updated"`

	R *orderDealR `boil:"-" json:"-" toml:"-" yaml:"-"`
	L orderDealL  `boil:"-" json:"-" toml:"-" yaml:"-"`
}

var OrderDealColumns = struct {
	ID        string
	OrderID   string
	OfferID   string
	DriverID  string
	Price     string
	Rating    string
	Completed string
	DTCreated string
	DTUpdated string
}{
	ID:        "id",
	OrderID:   "order_id",
	OfferID:   "offer_id",
	DriverID:  "driver_id",
	Price:     "price",
	Rating:    "rating",
	Completed: "completed",
	DTCreated: "dt_created",
	DTUpdated: "dt_updated",
}

// Generated where

type whereHelperbool struct{ field string }

func (w whereHelperbool) EQ(x bool) qm.QueryMod  { return qmhelper.Where(w.field, qmhelper.EQ, x) }
func (w whereHelperbool) NEQ(x bool) qm.QueryMod { return qmhelper.Where(w.field, qmhelper.NEQ, x) }
func (w whereHelperbool) LT(x bool) qm.QueryMod  { return qmhelper.Where(w.field, qmhelper.LT, x) }
func (w whereHelperbool) LTE(x bool) qm.QueryMod { return qmhelper.Where(w.field, qmhelper.LTE, x) }
func (w whereHelperbool) GT(x bool) qm.QueryMod  { return qmhelper.Where(w.field, qmhelper.GT, x) }
func (w whereHelperbool) GTE(x bool) qm.QueryMod { return qmhelper.Where(w.field, qmhelper.GTE, x) }

var OrderDealWhere = struct {
	ID        whereHelperint64
	OrderID   whereHelperint64
	OfferID   whereHelperint64
	DriverID  whereHelperint64
	Price     whereHelperint64
	Rating    whereHelpertypes_NullDecimal
	Completed whereHelperbool
	DTCreated whereHelpertime_Time
	DTUpdated whereHelpertime_Time
}{
	ID:        whereHelperint64{field: "\"order_deal\".\"id\""},
	OrderID:   whereHelperint64{field: "\"order_deal\".\"order_id\""},
	OfferID:   whereHelperint64{field: "\"order_deal\".\"offer_id\""},
	DriverID:  whereHelperint64{field: "\"order_deal\".\"driver_id\""},
	Price:     whereHelperint64{field: "\"order_deal\".\"price\""},
	Rating:    whereHelpertypes_NullDecimal{field: "\"order_deal\".\"rating\""},
	Completed: whereHelperbool{field: "\"order_deal\".\"completed\""},
	DTCreated: whereHelpertime_Time{field: "\"order_deal\".\"dt_created\""},
	DTUpdated: whereHelpertime_Time{field: "\"order_deal\".\"dt_updated\""},
}

// OrderDealRels is where relationship names are stored.
var OrderDealRels = struct {
	Order  string
	Offer  string
	Driver string
}{
	Order:  "Order",
	Offer:  "Offer",
	Driver: "Driver",
}

// orderDealR is where relationships are stored.
type orderDealR struct {
	Order  *Order
	Offer  *Offer
	Driver *Driver
}

// NewStruct creates a new relationship struct
func (*orderDealR) NewStruct() *orderDealR {
	return &orderDealR{}
}

// orderDealL is where Load methods for each relationship are stored.
type orderDealL struct{}

var (
	orderDealColumns               = []string{"id", "order_id", "offer_id", "driver_id", "price", "rating", "completed", "dt_created", "dt_updated"}
	orderDealColumnsWithoutDefault = []string{"order_id", "offer_id", "driver_id", "price", "rating"}
	orderDealColumnsWithDefault    = []string{"id", "completed", "dt_created", "dt_updated"}
	orderDealPrimaryKeyColumns     = []string{"id"}
)

type (
	// OrderDealSlice is an alias for a slice of pointers to OrderDeal.
	// This should generally be used opposed to []OrderDeal.
	OrderDealSlice []*OrderDeal
	// OrderDealHook is the signature for custom OrderDeal hook methods
	OrderDealHook func(context.Context, boil.ContextExecutor, *OrderDeal) error

	orderDealQuery struct {
		*queries.Query
	}
)

// Cache for insert, update and upsert
var (
	orderDealType                 = reflect.TypeOf(&OrderDeal{})
	orderDealMapping              = queries.MakeStructMapping(orderDealType)
	orderDealPrimaryKeyMapping, _ = queries.BindMapping(orderDealType, orderDealMapping, orderDealPrimaryKeyColumns)
	orderDealInsertCacheMut       sync.RWMutex
	orderDealInsertCache          = make(map[string]insertCache)
	orderDealUpdateCacheMut       sync.RWMutex
	orderDealUpdateCache          = make(map[string]updateCache)
	orderDealUpsertCacheMut       sync.RWMutex
	orderDealUpsertCache          = make(map[string]insertCache)
)

var (
	// Force time package dependency for automated UpdatedAt/CreatedAt.
	_ = time.Second
	// Force qmhelper dependency for where clause generation (which doesn't
	// always happen)
	_ = qmhelper.Where
)

var orderDealBeforeInsertHooks []OrderDealHook
var orderDealBeforeUpdateHooks []OrderDealHook
var orderDealBeforeDeleteHooks []OrderDealHook
var orderDealBeforeUpsertHooks []OrderDealHook

var orderDealAfterInsertHooks []OrderDealHook
var orderDealAfterSelectHooks []OrderDealHook
var orderDealAfterUpdateHooks []OrderDealHook
var orderDealAfterDeleteHooks []OrderDealHook
var orderDealAfterUpsertHooks []OrderDealHook

// doBeforeInsertHooks executes all "before insert" hooks.
func (o *OrderDeal) doBeforeInsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range orderDealBeforeInsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeUpdateHooks executes all "before Update" hooks.
func (o *OrderDeal) doBeforeUpdateHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range orderDealBeforeUpdateHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeDeleteHooks executes all "before Delete" hooks.
func (o *OrderDeal) doBeforeDeleteHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range orderDealBeforeDeleteHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeUpsertHooks executes all "before Upsert" hooks.
func (o *OrderDeal) doBeforeUpsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range orderDealBeforeUpsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterInsertHooks executes all "after Insert" hooks.
func (o *OrderDeal) doAfterInsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range orderDealAfterInsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterSelectHooks executes all "after Select" hooks.
func (o *OrderDeal) doAfterSelectHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range orderDealAfterSelectHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterUpdateHooks executes all "after Update" hooks.
func (o *OrderDeal) doAfterUpdateHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range orderDealAfterUpdateHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterDeleteHooks executes all "after Delete" hooks.
func (o *OrderDeal) doAfterDeleteHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range orderDealAfterDeleteHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterUpsertHooks executes all "after Upsert" hooks.
func (o *OrderDeal) doAfterUpsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range orderDealAfterUpsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// AddOrderDealHook registers your hook function for all future operations.
func AddOrderDealHook(hookPoint boil.HookPoint, orderDealHook OrderDealHook) {
	switch hookPoint {
	case boil.BeforeInsertHook:
		orderDealBeforeInsertHooks = append(orderDealBeforeInsertHooks, orderDealHook)
	case boil.BeforeUpdateHook:
		orderDealBeforeUpdateHooks = append(orderDealBeforeUpdateHooks, orderDealHook)
	case boil.BeforeDeleteHook:
		orderDealBeforeDeleteHooks = append(orderDealBeforeDeleteHooks, orderDealHook)
	case boil.BeforeUpsertHook:
		orderDealBeforeUpsertHooks = append(orderDealBeforeUpsertHooks, orderDealHook)
	case boil.AfterInsertHook:
		orderDealAfterInsertHooks = append(orderDealAfterInsertHooks, orderDealHook)
	case boil.AfterSelectHook:
		orderDealAfterSelectHooks = append(orderDealAfterSelectHooks, orderDealHook)
	case boil.AfterUpdateHook:
		orderDealAfterUpdateHooks = append(orderDealAfterUpdateHooks, orderDealHook)
	case boil.AfterDeleteHook:
		orderDealAfterDeleteHooks = append(orderDealAfterDeleteHooks, orderDealHook)
	case boil.AfterUpsertHook:
		orderDealAfterUpsertHooks = append(orderDealAfterUpsertHooks, orderDealHook)
	}
}

// One returns a single orderDeal record from the query.
func (q orderDealQuery) One(ctx context.Context, exec boil.ContextExecutor) (*OrderDeal, error) {
	o := &OrderDeal{}

	queries.SetLimit(q.Query, 1)

	err := q.Bind(ctx, exec, o)
	if err != nil {
		if errors.Cause(err) == sql.ErrNoRows {
			return nil, sql.ErrNoRows
		}
		return nil, errors.Wrap(err, "postgres: failed to execute a one query for order_deal")
	}

	if err := o.doAfterSelectHooks(ctx, exec); err != nil {
		return o, err
	}

	return o, nil
}

// All returns all OrderDeal records from the query.
func (q orderDealQuery) All(ctx context.Context, exec boil.ContextExecutor) (OrderDealSlice, error) {
	var o []*OrderDeal

	err := q.Bind(ctx, exec, &o)
	if err != nil {
		return nil, errors.Wrap(err, "postgres: failed to assign all query results to OrderDeal slice")
	}

	if len(orderDealAfterSelectHooks) != 0 {
		for _, obj := range o {
			if err := obj.doAfterSelectHooks(ctx, exec); err != nil {
				return o, err
			}
		}
	}

	return o, nil
}

// Count returns the count of all OrderDeal records in the query.
func (q orderDealQuery) Count(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	var count int64

	queries.SetSelect(q.Query, nil)
	queries.SetCount(q.Query)

	err := q.Query.QueryRowContext(ctx, exec).Scan(&count)
	if err != nil {
		return 0, errors.Wrap(err, "postgres: failed to count order_deal rows")
	}

	return count, nil
}

// Exists checks if the row exists in the table.
func (q orderDealQuery) Exists(ctx context.Context, exec boil.ContextExecutor) (bool, error) {
	var count int64

	queries.SetSelect(q.Query, nil)
	queries.SetCount(q.Query)
	queries.SetLimit(q.Query, 1)

	err := q.Query.QueryRowContext(ctx, exec).Scan(&count)
	if err != nil {
		return false, errors.Wrap(err, "postgres: failed to check if order_deal exists")
	}

	return count > 0, nil
}

// Order pointed to by the foreign key.
func (o *OrderDeal) Order(mods ...qm.QueryMod) orderQuery {
	queryMods := []qm.QueryMod{
		qm.Where("id=?", o.OrderID),
	}

	queryMods = append(queryMods, mods...)

	query := Orders(queryMods...)
	queries.SetFrom(query.Query, "\"order\"")

	return query
}

// Offer pointed to by the foreign key.
func (o *OrderDeal) Offer(mods ...qm.QueryMod) offerQuery {
	queryMods := []qm.QueryMod{
		qm.Where("id=?", o.OfferID),
	}

	queryMods = append(queryMods, mods...)

	query := Offers(queryMods...)
	queries.SetFrom(query.Query, "\"offer\"")

	return query
}

// Driver pointed to by the foreign key.
func (o *OrderDeal) Driver(mods ...qm.QueryMod) driverQuery {
	queryMods := []qm.QueryMod{
		qm.Where("id=?", o.DriverID),
	}

	queryMods = append(queryMods, mods...)

	query := Drivers(queryMods...)
	queries.SetFrom(query.Query, "\"driver\"")

	return query
}

// LoadOrder allows an eager lookup of values, cached into the
// loaded structs of the objects. This is for an N-1 relationship.
func (orderDealL) LoadOrder(ctx context.Context, e boil.ContextExecutor, singular bool, maybeOrderDeal interface{}, mods queries.Applicator) error {
	var slice []*OrderDeal
	var object *OrderDeal

	if singular {
		object = maybeOrderDeal.(*OrderDeal)
	} else {
		slice = *maybeOrderDeal.(*[]*OrderDeal)
	}

	args := make([]interface{}, 0, 1)
	if singular {
		if object.R == nil {
			object.R = &orderDealR{}
		}
		args = append(args, object.OrderID)

	} else {
	Outer:
		for _, obj := range slice {
			if obj.R == nil {
				obj.R = &orderDealR{}
			}

			for _, a := range args {
				if a == obj.OrderID {
					continue Outer
				}
			}

			args = append(args, obj.OrderID)

		}
	}

	if len(args) == 0 {
		return nil
	}

	query := NewQuery(qm.From(`order`), qm.WhereIn(`id in ?`, args...))
	if mods != nil {
		mods.Apply(query)
	}

	results, err := query.QueryContext(ctx, e)
	if err != nil {
		return errors.Wrap(err, "failed to eager load Order")
	}

	var resultSlice []*Order
	if err = queries.Bind(results, &resultSlice); err != nil {
		return errors.Wrap(err, "failed to bind eager loaded slice Order")
	}

	if err = results.Close(); err != nil {
		return errors.Wrap(err, "failed to close results of eager load for order")
	}
	if err = results.Err(); err != nil {
		return errors.Wrap(err, "error occurred during iteration of eager loaded relations for order")
	}

	if len(orderDealAfterSelectHooks) != 0 {
		for _, obj := range resultSlice {
			if err := obj.doAfterSelectHooks(ctx, e); err != nil {
				return err
			}
		}
	}

	if len(resultSlice) == 0 {
		return nil
	}

	if singular {
		foreign := resultSlice[0]
		object.R.Order = foreign
		if foreign.R == nil {
			foreign.R = &orderR{}
		}
		foreign.R.OrderDeals = append(foreign.R.OrderDeals, object)
		return nil
	}

	for _, local := range slice {
		for _, foreign := range resultSlice {
			if local.OrderID == foreign.ID {
				local.R.Order = foreign
				if foreign.R == nil {
					foreign.R = &orderR{}
				}
				foreign.R.OrderDeals = append(foreign.R.OrderDeals, local)
				break
			}
		}
	}

	return nil
}

// LoadOffer allows an eager lookup of values, cached into the
// loaded structs of the objects. This is for an N-1 relationship.
func (orderDealL) LoadOffer(ctx context.Context, e boil.ContextExecutor, singular bool, maybeOrderDeal interface{}, mods queries.Applicator) error {
	var slice []*OrderDeal
	var object *OrderDeal

	if singular {
		object = maybeOrderDeal.(*OrderDeal)
	} else {
		slice = *maybeOrderDeal.(*[]*OrderDeal)
	}

	args := make([]interface{}, 0, 1)
	if singular {
		if object.R == nil {
			object.R = &orderDealR{}
		}
		args = append(args, object.OfferID)

	} else {
	Outer:
		for _, obj := range slice {
			if obj.R == nil {
				obj.R = &orderDealR{}
			}

			for _, a := range args {
				if a == obj.OfferID {
					continue Outer
				}
			}

			args = append(args, obj.OfferID)

		}
	}

	if len(args) == 0 {
		return nil
	}

	query := NewQuery(qm.From(`offer`), qm.WhereIn(`id in ?`, args...))
	if mods != nil {
		mods.Apply(query)
	}

	results, err := query.QueryContext(ctx, e)
	if err != nil {
		return errors.Wrap(err, "failed to eager load Offer")
	}

	var resultSlice []*Offer
	if err = queries.Bind(results, &resultSlice); err != nil {
		return errors.Wrap(err, "failed to bind eager loaded slice Offer")
	}

	if err = results.Close(); err != nil {
		return errors.Wrap(err, "failed to close results of eager load for offer")
	}
	if err = results.Err(); err != nil {
		return errors.Wrap(err, "error occurred during iteration of eager loaded relations for offer")
	}

	if len(orderDealAfterSelectHooks) != 0 {
		for _, obj := range resultSlice {
			if err := obj.doAfterSelectHooks(ctx, e); err != nil {
				return err
			}
		}
	}

	if len(resultSlice) == 0 {
		return nil
	}

	if singular {
		foreign := resultSlice[0]
		object.R.Offer = foreign
		if foreign.R == nil {
			foreign.R = &offerR{}
		}
		foreign.R.OrderDeals = append(foreign.R.OrderDeals, object)
		return nil
	}

	for _, local := range slice {
		for _, foreign := range resultSlice {
			if local.OfferID == foreign.ID {
				local.R.Offer = foreign
				if foreign.R == nil {
					foreign.R = &offerR{}
				}
				foreign.R.OrderDeals = append(foreign.R.OrderDeals, local)
				break
			}
		}
	}

	return nil
}

// LoadDriver allows an eager lookup of values, cached into the
// loaded structs of the objects. This is for an N-1 relationship.
func (orderDealL) LoadDriver(ctx context.Context, e boil.ContextExecutor, singular bool, maybeOrderDeal interface{}, mods queries.Applicator) error {
	var slice []*OrderDeal
	var object *OrderDeal

	if singular {
		object = maybeOrderDeal.(*OrderDeal)
	} else {
		slice = *maybeOrderDeal.(*[]*OrderDeal)
	}

	args := make([]interface{}, 0, 1)
	if singular {
		if object.R == nil {
			object.R = &orderDealR{}
		}
		args = append(args, object.DriverID)

	} else {
	Outer:
		for _, obj := range slice {
			if obj.R == nil {
				obj.R = &orderDealR{}
			}

			for _, a := range args {
				if a == obj.DriverID {
					continue Outer
				}
			}

			args = append(args, obj.DriverID)

		}
	}

	if len(args) == 0 {
		return nil
	}

	query := NewQuery(qm.From(`driver`), qm.WhereIn(`id in ?`, args...))
	if mods != nil {
		mods.Apply(query)
	}

	results, err := query.QueryContext(ctx, e)
	if err != nil {
		return errors.Wrap(err, "failed to eager load Driver")
	}

	var resultSlice []*Driver
	if err = queries.Bind(results, &resultSlice); err != nil {
		return errors.Wrap(err, "failed to bind eager loaded slice Driver")
	}

	if err = results.Close(); err != nil {
		return errors.Wrap(err, "failed to close results of eager load for driver")
	}
	if err = results.Err(); err != nil {
		return errors.Wrap(err, "error occurred during iteration of eager loaded relations for driver")
	}

	if len(orderDealAfterSelectHooks) != 0 {
		for _, obj := range resultSlice {
			if err := obj.doAfterSelectHooks(ctx, e); err != nil {
				return err
			}
		}
	}

	if len(resultSlice) == 0 {
		return nil
	}

	if singular {
		foreign := resultSlice[0]
		object.R.Driver = foreign
		if foreign.R == nil {
			foreign.R = &driverR{}
		}
		foreign.R.OrderDeals = append(foreign.R.OrderDeals, object)
		return nil
	}

	for _, local := range slice {
		for _, foreign := range resultSlice {
			if local.DriverID == foreign.ID {
				local.R.Driver = foreign
				if foreign.R == nil {
					foreign.R = &driverR{}
				}
				foreign.R.OrderDeals = append(foreign.R.OrderDeals, local)
				break
			}
		}
	}

	return nil
}

// SetOrder of the orderDeal to the related item.
// Sets o.R.Order to related.
// Adds o to related.R.OrderDeals.
func (o *OrderDeal) SetOrder(ctx context.Context, exec boil.ContextExecutor, insert bool, related *Order) error {
	var err error
	if insert {
		if err = related.Insert(ctx, exec, boil.Infer()); err != nil {
			return errors.Wrap(err, "failed to insert into foreign table")
		}
	}

	updateQuery := fmt.Sprintf(
		"UPDATE \"order_deal\" SET %s WHERE %s",
		strmangle.SetParamNames("\"", "\"", 1, []string{"order_id"}),
		strmangle.WhereClause("\"", "\"", 2, orderDealPrimaryKeyColumns),
	)
	values := []interface{}{related.ID, o.ID}

	if boil.DebugMode {
		fmt.Fprintln(boil.DebugWriter, updateQuery)
		fmt.Fprintln(boil.DebugWriter, values)
	}

	if _, err = exec.ExecContext(ctx, updateQuery, values...); err != nil {
		return errors.Wrap(err, "failed to update local table")
	}

	o.OrderID = related.ID
	if o.R == nil {
		o.R = &orderDealR{
			Order: related,
		}
	} else {
		o.R.Order = related
	}

	if related.R == nil {
		related.R = &orderR{
			OrderDeals: OrderDealSlice{o},
		}
	} else {
		related.R.OrderDeals = append(related.R.OrderDeals, o)
	}

	return nil
}

// SetOffer of the orderDeal to the related item.
// Sets o.R.Offer to related.
// Adds o to related.R.OrderDeals.
func (o *OrderDeal) SetOffer(ctx context.Context, exec boil.ContextExecutor, insert bool, related *Offer) error {
	var err error
	if insert {
		if err = related.Insert(ctx, exec, boil.Infer()); err != nil {
			return errors.Wrap(err, "failed to insert into foreign table")
		}
	}

	updateQuery := fmt.Sprintf(
		"UPDATE \"order_deal\" SET %s WHERE %s",
		strmangle.SetParamNames("\"", "\"", 1, []string{"offer_id"}),
		strmangle.WhereClause("\"", "\"", 2, orderDealPrimaryKeyColumns),
	)
	values := []interface{}{related.ID, o.ID}

	if boil.DebugMode {
		fmt.Fprintln(boil.DebugWriter, updateQuery)
		fmt.Fprintln(boil.DebugWriter, values)
	}

	if _, err = exec.ExecContext(ctx, updateQuery, values...); err != nil {
		return errors.Wrap(err, "failed to update local table")
	}

	o.OfferID = related.ID
	if o.R == nil {
		o.R = &orderDealR{
			Offer: related,
		}
	} else {
		o.R.Offer = related
	}

	if related.R == nil {
		related.R = &offerR{
			OrderDeals: OrderDealSlice{o},
		}
	} else {
		related.R.OrderDeals = append(related.R.OrderDeals, o)
	}

	return nil
}

// SetDriver of the orderDeal to the related item.
// Sets o.R.Driver to related.
// Adds o to related.R.OrderDeals.
func (o *OrderDeal) SetDriver(ctx context.Context, exec boil.ContextExecutor, insert bool, related *Driver) error {
	var err error
	if insert {
		if err = related.Insert(ctx, exec, boil.Infer()); err != nil {
			return errors.Wrap(err, "failed to insert into foreign table")
		}
	}

	updateQuery := fmt.Sprintf(
		"UPDATE \"order_deal\" SET %s WHERE %s",
		strmangle.SetParamNames("\"", "\"", 1, []string{"driver_id"}),
		strmangle.WhereClause("\"", "\"", 2, orderDealPrimaryKeyColumns),
	)
	values := []interface{}{related.ID, o.ID}

	if boil.DebugMode {
		fmt.Fprintln(boil.DebugWriter, updateQuery)
		fmt.Fprintln(boil.DebugWriter, values)
	}

	if _, err = exec.ExecContext(ctx, updateQuery, values...); err != nil {
		return errors.Wrap(err, "failed to update local table")
	}

	o.DriverID = related.ID
	if o.R == nil {
		o.R = &orderDealR{
			Driver: related,
		}
	} else {
		o.R.Driver = related
	}

	if related.R == nil {
		related.R = &driverR{
			OrderDeals: OrderDealSlice{o},
		}
	} else {
		related.R.OrderDeals = append(related.R.OrderDeals, o)
	}

	return nil
}

// OrderDeals retrieves all the records using an executor.
func OrderDeals(mods ...qm.QueryMod) orderDealQuery {
	mods = append(mods, qm.From("\"order_deal\""))
	return orderDealQuery{NewQuery(mods...)}
}

// FindOrderDeal retrieves a single record by ID with an executor.
// If selectCols is empty Find will return all columns.
func FindOrderDeal(ctx context.Context, exec boil.ContextExecutor, iD int64, selectCols ...string) (*OrderDeal, error) {
	orderDealObj := &OrderDeal{}

	sel := "*"
	if len(selectCols) > 0 {
		sel = strings.Join(strmangle.IdentQuoteSlice(dialect.LQ, dialect.RQ, selectCols), ",")
	}
	query := fmt.Sprintf(
		"select %s from \"order_deal\" where \"id\"=$1", sel,
	)

	q := queries.Raw(query, iD)

	err := q.Bind(ctx, exec, orderDealObj)
	if err != nil {
		if errors.Cause(err) == sql.ErrNoRows {
			return nil, sql.ErrNoRows
		}
		return nil, errors.Wrap(err, "postgres: unable to select from order_deal")
	}

	return orderDealObj, nil
}

// Insert a single record using an executor.
// See boil.Columns.InsertColumnSet documentation to understand column list inference for inserts.
func (o *OrderDeal) Insert(ctx context.Context, exec boil.ContextExecutor, columns boil.Columns) error {
	if o == nil {
		return errors.New("postgres: no order_deal provided for insertion")
	}

	var err error

	if err := o.doBeforeInsertHooks(ctx, exec); err != nil {
		return err
	}

	nzDefaults := queries.NonZeroDefaultSet(orderDealColumnsWithDefault, o)

	key := makeCacheKey(columns, nzDefaults)
	orderDealInsertCacheMut.RLock()
	cache, cached := orderDealInsertCache[key]
	orderDealInsertCacheMut.RUnlock()

	if !cached {
		wl, returnColumns := columns.InsertColumnSet(
			orderDealColumns,
			orderDealColumnsWithDefault,
			orderDealColumnsWithoutDefault,
			nzDefaults,
		)

		cache.valueMapping, err = queries.BindMapping(orderDealType, orderDealMapping, wl)
		if err != nil {
			return err
		}
		cache.retMapping, err = queries.BindMapping(orderDealType, orderDealMapping, returnColumns)
		if err != nil {
			return err
		}
		if len(wl) != 0 {
			cache.query = fmt.Sprintf("INSERT INTO \"order_deal\" (\"%s\") %%sVALUES (%s)%%s", strings.Join(wl, "\",\""), strmangle.Placeholders(dialect.UseIndexPlaceholders, len(wl), 1, 1))
		} else {
			cache.query = "INSERT INTO \"order_deal\" %sDEFAULT VALUES%s"
		}

		var queryOutput, queryReturning string

		if len(cache.retMapping) != 0 {
			queryReturning = fmt.Sprintf(" RETURNING \"%s\"", strings.Join(returnColumns, "\",\""))
		}

		cache.query = fmt.Sprintf(cache.query, queryOutput, queryReturning)
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	vals := queries.ValuesFromMapping(value, cache.valueMapping)

	if boil.DebugMode {
		fmt.Fprintln(boil.DebugWriter, cache.query)
		fmt.Fprintln(boil.DebugWriter, vals)
	}

	if len(cache.retMapping) != 0 {
		err = exec.QueryRowContext(ctx, cache.query, vals...).Scan(queries.PtrsFromMapping(value, cache.retMapping)...)
	} else {
		_, err = exec.ExecContext(ctx, cache.query, vals...)
	}

	if err != nil {
		return errors.Wrap(err, "postgres: unable to insert into order_deal")
	}

	if !cached {
		orderDealInsertCacheMut.Lock()
		orderDealInsertCache[key] = cache
		orderDealInsertCacheMut.Unlock()
	}

	return o.doAfterInsertHooks(ctx, exec)
}

// Update uses an executor to update the OrderDeal.
// See boil.Columns.UpdateColumnSet documentation to understand column list inference for updates.
// Update does not automatically update the record in case of default values. Use .Reload() to refresh the records.
func (o *OrderDeal) Update(ctx context.Context, exec boil.ContextExecutor, columns boil.Columns) (int64, error) {
	var err error
	if err = o.doBeforeUpdateHooks(ctx, exec); err != nil {
		return 0, err
	}
	key := makeCacheKey(columns, nil)
	orderDealUpdateCacheMut.RLock()
	cache, cached := orderDealUpdateCache[key]
	orderDealUpdateCacheMut.RUnlock()

	if !cached {
		wl := columns.UpdateColumnSet(
			orderDealColumns,
			orderDealPrimaryKeyColumns,
		)

		if !columns.IsWhitelist() {
			wl = strmangle.SetComplement(wl, []string{"created_at"})
		}
		if len(wl) == 0 {
			return 0, errors.New("postgres: unable to update order_deal, could not build whitelist")
		}

		cache.query = fmt.Sprintf("UPDATE \"order_deal\" SET %s WHERE %s",
			strmangle.SetParamNames("\"", "\"", 1, wl),
			strmangle.WhereClause("\"", "\"", len(wl)+1, orderDealPrimaryKeyColumns),
		)
		cache.valueMapping, err = queries.BindMapping(orderDealType, orderDealMapping, append(wl, orderDealPrimaryKeyColumns...))
		if err != nil {
			return 0, err
		}
	}

	values := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(o)), cache.valueMapping)

	if boil.DebugMode {
		fmt.Fprintln(boil.DebugWriter, cache.query)
		fmt.Fprintln(boil.DebugWriter, values)
	}

	var result sql.Result
	result, err = exec.ExecContext(ctx, cache.query, values...)
	if err != nil {
		return 0, errors.Wrap(err, "postgres: unable to update order_deal row")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "postgres: failed to get rows affected by update for order_deal")
	}

	if !cached {
		orderDealUpdateCacheMut.Lock()
		orderDealUpdateCache[key] = cache
		orderDealUpdateCacheMut.Unlock()
	}

	return rowsAff, o.doAfterUpdateHooks(ctx, exec)
}

// UpdateAll updates all rows with the specified column values.
func (q orderDealQuery) UpdateAll(ctx context.Context, exec boil.ContextExecutor, cols M) (int64, error) {
	queries.SetUpdate(q.Query, cols)

	result, err := q.Query.ExecContext(ctx, exec)
	if err != nil {
		return 0, errors.Wrap(err, "postgres: unable to update all for order_deal")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "postgres: unable to retrieve rows affected for order_deal")
	}

	return rowsAff, nil
}

// UpdateAll updates all rows with the specified column values, using an executor.
func (o OrderDealSlice) UpdateAll(ctx context.Context, exec boil.ContextExecutor, cols M) (int64, error) {
	ln := int64(len(o))
	if ln == 0 {
		return 0, nil
	}

	if len(cols) == 0 {
		return 0, errors.New("postgres: update all requires at least one column argument")
	}

	colNames := make([]string, len(cols))
	args := make([]interface{}, len(cols))

	i := 0
	for name, value := range cols {
		colNames[i] = name
		args[i] = value
		i++
	}

	// Append all of the primary key values for each column
	for _, obj := range o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), orderDealPrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := fmt.Sprintf("UPDATE \"order_deal\" SET %s WHERE %s",
		strmangle.SetParamNames("\"", "\"", 1, colNames),
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), len(colNames)+1, orderDealPrimaryKeyColumns, len(o)))

	if boil.DebugMode {
		fmt.Fprintln(boil.DebugWriter, sql)
		fmt.Fprintln(boil.DebugWriter, args...)
	}

	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "postgres: unable to update all in orderDeal slice")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "postgres: unable to retrieve rows affected all in update all orderDeal")
	}
	return rowsAff, nil
}

// Upsert attempts an insert using an executor, and does an update or ignore on conflict.
// See boil.Columns documentation for how to properly use updateColumns and insertColumns.
func (o *OrderDeal) Upsert(ctx context.Context, exec boil.ContextExecutor, updateOnConflict bool, conflictColumns []string, updateColumns, insertColumns boil.Columns) error {
	if o == nil {
		return errors.New("postgres: no order_deal provided for upsert")
	}

	if err := o.doBeforeUpsertHooks(ctx, exec); err != nil {
		return err
	}

	nzDefaults := queries.NonZeroDefaultSet(orderDealColumnsWithDefault, o)

	// Build cache key in-line uglily - mysql vs psql problems
	buf := strmangle.GetBuffer()
	if updateOnConflict {
		buf.WriteByte('t')
	} else {
		buf.WriteByte('f')
	}
	buf.WriteByte('.')
	for _, c := range conflictColumns {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	buf.WriteString(strconv.Itoa(updateColumns.Kind))
	for _, c := range updateColumns.Cols {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	buf.WriteString(strconv.Itoa(insertColumns.Kind))
	for _, c := range insertColumns.Cols {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	for _, c := range nzDefaults {
		buf.WriteString(c)
	}
	key := buf.String()
	strmangle.PutBuffer(buf)

	orderDealUpsertCacheMut.RLock()
	cache, cached := orderDealUpsertCache[key]
	orderDealUpsertCacheMut.RUnlock()

	var err error

	if !cached {
		insert, ret := insertColumns.InsertColumnSet(
			orderDealColumns,
			orderDealColumnsWithDefault,
			orderDealColumnsWithoutDefault,
			nzDefaults,
		)
		update := updateColumns.UpdateColumnSet(
			orderDealColumns,
			orderDealPrimaryKeyColumns,
		)

		if len(update) == 0 {
			return errors.New("postgres: unable to upsert order_deal, could not build update column list")
		}

		conflict := conflictColumns
		if len(conflict) == 0 {
			conflict = make([]string, len(orderDealPrimaryKeyColumns))
			copy(conflict, orderDealPrimaryKeyColumns)
		}
		cache.query = buildUpsertQueryPostgres(dialect, "\"order_deal\"", updateOnConflict, ret, update, conflict, insert)

		cache.valueMapping, err = queries.BindMapping(orderDealType, orderDealMapping, insert)
		if err != nil {
			return err
		}
		if len(ret) != 0 {
			cache.retMapping, err = queries.BindMapping(orderDealType, orderDealMapping, ret)
			if err != nil {
				return err
			}
		}
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	vals := queries.ValuesFromMapping(value, cache.valueMapping)
	var returns []interface{}
	if len(cache.retMapping) != 0 {
		returns = queries.PtrsFromMapping(value, cache.retMapping)
	}

	if boil.DebugMode {
		fmt.Fprintln(boil.DebugWriter, cache.query)
		fmt.Fprintln(boil.DebugWriter, vals)
	}

	if len(cache.retMapping) != 0 {
		err = exec.QueryRowContext(ctx, cache.query, vals...).Scan(returns...)
		if err == sql.ErrNoRows {
			err = nil // Postgres doesn't return anything when there's no update
		}
	} else {
		_, err = exec.ExecContext(ctx, cache.query, vals...)
	}
	if err != nil {
		return errors.Wrap(err, "postgres: unable to upsert order_deal")
	}

	if !cached {
		orderDealUpsertCacheMut.Lock()
		orderDealUpsertCache[key] = cache
		orderDealUpsertCacheMut.Unlock()
	}

	return o.doAfterUpsertHooks(ctx, exec)
}

// Delete deletes a single OrderDeal record with an executor.
// Delete will match against the primary key column to find the record to delete.
func (o *OrderDeal) Delete(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if o == nil {
		return 0, errors.New("postgres: no OrderDeal provided for delete")
	}

	if err := o.doBeforeDeleteHooks(ctx, exec); err != nil {
		return 0, err
	}

	args := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(o)), orderDealPrimaryKeyMapping)
	sql := "DELETE FROM \"order_deal\" WHERE \"id\"=$1"

	if boil.DebugMode {
		fmt.Fprintln(boil.DebugWriter, sql)
		fmt.Fprintln(boil.DebugWriter, args...)
	}

	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "postgres: unable to delete from order_deal")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "postgres: failed to get rows affected by delete for order_deal")
	}

	if err := o.doAfterDeleteHooks(ctx, exec); err != nil {
		return 0, err
	}

	return rowsAff, nil
}

// DeleteAll deletes all matching rows.
func (q orderDealQuery) DeleteAll(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if q.Query == nil {
		return 0, errors.New("postgres: no orderDealQuery provided for delete all")
	}

	queries.SetDelete(q.Query)

	result, err := q.Query.ExecContext(ctx, exec)
	if err != nil {
		return 0, errors.Wrap(err, "postgres: unable to delete all from order_deal")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "postgres: failed to get rows affected by deleteall for order_deal")
	}

	return rowsAff, nil
}

// DeleteAll deletes all rows in the slice, using an executor.
func (o OrderDealSlice) DeleteAll(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if len(o) == 0 {
		return 0, nil
	}

	if len(orderDealBeforeDeleteHooks) != 0 {
		for _, obj := range o {
			if err := obj.doBeforeDeleteHooks(ctx, exec); err != nil {
				return 0, err
			}
		}
	}

	var args []interface{}
	for _, obj := range o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), orderDealPrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := "DELETE FROM \"order_deal\" WHERE " +
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), 1, orderDealPrimaryKeyColumns, len(o))

	if boil.DebugMode {
		fmt.Fprintln(boil.DebugWriter, sql)
		fmt.Fprintln(boil.DebugWriter, args)
	}

	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "postgres: unable to delete all from orderDeal slice")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "postgres: failed to get rows affected by deleteall for order_deal")
	}

	if len(orderDealAfterDeleteHooks) != 0 {
		for _, obj := range o {
			if err := obj.doAfterDeleteHooks(ctx, exec); err != nil {
				return 0, err
			}
		}
	}

	return rowsAff, nil
}

// Reload refetches the object from the database
// using the primary keys with an executor.
func (o *OrderDeal) Reload(ctx context.Context, exec boil.ContextExecutor) error {
	ret, err := FindOrderDeal(ctx, exec, o.ID)
	if err != nil {
		return err
	}

	*o = *ret
	return nil
}

// ReloadAll refetches every row with matching primary key column values
// and overwrites the original object slice with the newly updated slice.
func (o *OrderDealSlice) ReloadAll(ctx context.Context, exec boil.ContextExecutor) error {
	if o == nil || len(*o) == 0 {
		return nil
	}

	slice := OrderDealSlice{}
	var args []interface{}
	for _, obj := range *o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), orderDealPrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := "SELECT \"order_deal\".* FROM \"order_deal\" WHERE " +
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), 1, orderDealPrimaryKeyColumns, len(*o))

	q := queries.Raw(sql, args...)

	err := q.Bind(ctx, exec, &slice)
	if err != nil {
		return errors.Wrap(err, "postgres: unable to reload all in OrderDealSlice")
	}

	*o = slice

	return nil
}

// OrderDealExists checks if the OrderDeal row exists.
func OrderDealExists(ctx context.Context, exec boil.ContextExecutor, iD int64) (bool, error) {
	var exists bool
	sql := "select exists(select 1 from \"order_deal\" where \"id\"=$1 limit 1)"

	if boil.DebugMode {
		fmt.Fprintln(boil.DebugWriter, sql)
		fmt.Fprintln(boil.DebugWriter, iD)
	}

	row := exec.QueryRowContext(ctx, sql, iD)

	err := row.Scan(&exists)
	if err != nil {
		return false, errors.Wrap(err, "postgres: unable to check if order_deal exists")
	}

	return exists, nil
}
